package gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;

import company.*;

/**
 * Handles Change menu item action
 */
public class ChangeActionHandler implements ActionListener {

    /*
     * State variables
     */
    private Company _company;

    private Random rand = new Random();

    private boolean transferChange = false;

    /** Initialize action */
    public ChangeActionHandler(Company company) {
        _company = company;
    }

    /**
     * Handle menu item Exchanges the roles of two random employees
     */
    public void actionPerformed(ActionEvent e) {
        Employee empl1 = randomEmployee();

        if (empl1.getRole() == Employee.WORKER && transferChange) {
            Department deptm = randomDeptm();
            while (deptm == empl1.getDepartment()) {
                deptm = randomDeptm();
            }
            _company.transferTo(empl1, Employee.WORKER, deptm);
            transferChange = false;
        } else {
            Employee empl2 = randomEmployee();
            while (empl1 == empl2) {
                empl2 = randomEmployee();
            }
            _company.exchangeRoles(empl1, empl2);
            transferChange = true;
        }
    }

    /** Select random employee */
    private Employee randomEmployee() {
        if (rand.nextInt(7) == 0) {
            return _company.getCEO();
        }

        Department deptm = randomDeptm();

        if (rand.nextInt(3) == 0) {
            return deptm.getManager();
        }
        return (Employee)deptm._workers.get(rand.nextInt(deptm._workers.size()));
    }

    /** Select random department */
    private Department randomDeptm() {
        return _company.getDepartmentAt(rand.nextInt(_company
                .getDepartmentCount()));
    }
}