/*
 * Created on Sep 12, 2005
 */
package tree;

import java.util.NoSuchElementException;

/**
 * Common exceptions thrown by the tree browser.
 * @author stephan
 */
public class Errors {
	public static void childrenNotAllowed() {
		throw new IllegalStateException("node does not allow children");
	}
	public static void cannotRemoveChild() {
		throw new IllegalStateException("node cannot remove children");
	}
	public static void cannotSetParent() {
		throw new IllegalStateException("node cannot set parent");
	}
	public static void argumentIsNull() {
        throw new IllegalArgumentException("argument is null");
	}
	public static void argumentIsNotAChild() {
		throw new IllegalArgumentException("argument is not a child");
	}
	public static void nodeHasNoChildren() {
        throw new NoSuchElementException("node has no children");	
	}
	public static void siblingHasDifferentParent() {
		throw new Error("sibling has different parent");
	}
	public static void rootIsNull() {
		throw new IllegalArgumentException("root is null");
	}
	public static void rootCantBeNull() {
		throw new IllegalArgumentException("Root of tree is not allowed to be null");
	}
	public static void nodeHasNoParent() {
		throw new IllegalArgumentException("node does not have a parent.");
	}
}
